#!/usr/bin/python
# -*- coding: utf-8 -*-
import csv
import sys
import json

from vocabulary import *
from flight import Flight



class RewriterFromCSV(object):


    def __init__(self, voc : Vocabulary, df : str) :
        """
        Translate a dataFile using a given vocabulary
        """
        self.vocabulary : Vocabulary = voc
        self.dataFile : str = df


    def readAndRewrite(self):
        """
        """
        line : str
        f : Flight
        try:
            with open(self.dataFile, 'r') as source:
                for line in source:
                    line = line.strip()
                    if line != "" and line[0] != "#":
                        f = Flight(line, self.vocabulary)
                        ##Do what you need with the rewriting vector here ...
                        print("-----------------------------")
                        print(f)
                        print("Rewritten flight :", f.rewrite())
                        print("-----------------------------")

        except:
            raise Exception("Error while loading the dataFile %s"%(self.dataFile))


# program entry
if __name__ == "__main__":
    # check parameters
    if len(sys.argv)  < 3:
        print("Usage: python rewriterFromCSV.py <vocfile> <dataFile>")
    else:
        # read vocabulary file, then process csv data file
        if os.path.isfile(sys.argv[1]):
            # read file as vocabulary
            voc : Vocabulary = Vocabulary(sys.argv[1])
            if os.path.isfile(sys.argv[2]):
                # both files are ok, process the data
                rw : RewriterFromCSV = RewriterFromCSV(voc, sys.argv[2])
                rw.readAndRewrite()

                # record results into a JSON file
                #with open("results-"+sys.argv[2]+".json"", "w") as outfile:
                #    json.dump(results, outfile, indent=4))

            else:
                print(f"Data file {sys.argv[2]} not found")
        else:
            print(f"Voc file {sys.argv[1]} not found")
